const
 HOSTNAMELEN=256;
 PORTNAMELEN=256;
 ADDRESSLEN=HOSTNAMELEN+PORTNAMELEN;

type
 ptcpinfo=^tcpinfo;
 tcpinfo=record
  next:ptcpinfo;
  state:integer;
  localip:integer;
  localport:integer;
  remoteip:integer;
  remoteport:integer;
 end;
 AsnInteger=longint;
 asncounter=integer;
 asngauge=integer;
 asntimeticks=integer;
 pAsnInteger=^AsnInteger;
 a0i=array[0..999] of integer;
 AsnObjectIdentifier=record
  idLength:integer;
  ids:^a0i;
 end;
 pAsnObjectIdentifier=^AsnObjectIdentifier;
 AsnObjectName=AsnObjectIdentifier;
 AsnOctetString=record
  stream:^byte;{pointer to octet stream}
  length:integer;{number of octets in stream}
  dynamic:integer;{true if octets must be freed}
 end;
 AsnSequence=AsnOctetString;
 AsnImplicitSequence=AsnOctetString;
 AsnIPAddress=AsnOctetString;
 AsnDisplayString=AsnOctetString;
 AsnOpaque=AsnOctetString;
 AsnAny=record
  asnType:byte;
  case integer of {asnValue}
   0:(number:AsnInteger);
   1:(_string:AsnOctetString);
   2:(_object:AsnObjectIdentifier);
   3:(sequence:AsnSequence);
   4:(address:AsnIPAddress);
   5:(counter:AsnCounter);
   6:(gauge:AsnGauge);
   7:(ticks:AsnTimeticks);
   8:(arbitrary:AsnOpaque);
 end;
 AsnObjectSyntax=AsnAny;
 RFC1157VarBind=record
  name:AsnObjectName;
  value:AsnObjectSyntax;
 end;
 RFC1157VarBindList=record
  list:^RFC1157VarBind;
  len:integer;
 end;
 pRFC1157VarBindList=^RFC1157VarBindList;

 p_snmpextensioninit=function
  (dwTimeZeroReference:dword;hPollForTrapEvent:phandle;supportedView:pAsnObjectIdentifier):integer;stdcall;
 p_snmpextensionquery=function
  (requestType:byte;variableBindings:pRFC1157VarBindList;errorStatus:pAsnInteger;errorIndex:pAsnInteger):integer;stdcall;
var
 snmpextensioninit:p_snmpextensioninit;
 snmpextensionquery:p_snmpextensionquery;

procedure netstat(var ss:send_struct);

function LoadSNMP:boolean;
var
 h:thandle;
begin
{$ifdef debug}writeln('Loadsnmp');{$endif}
 result:=true;
 if (@snmpextensioninit<>nil) and (@snmpextensionquery<>nil) then exit;
 result:=false;
{$ifdef debug}writeln('Loadsnmp must load');{$endif}
 h:=LoadLibrary('inetmib1.dll');
 if h=0 then exit;
{$ifdef debug}writeln('Loadsnmp library loaded');{$endif}
 SnmpExtensionInit:=GetProcAddress(h,'SnmpExtensionInit');
 SnmpExtensionQuery:=GetProcAddress(h,'SnmpExtensionQuery');
{$ifdef debug}writeln('Loadsnmp getprocaddress');{$endif}
 if (@snmpextensioninit=nil) or (@snmpextensionquery=nil) then exit;
 result:=true;
{$ifdef debug}writeln('Loadsnmp success');{$endif}
end;

const
 ASN_CONTEXTSPECIFIC=$80;
 ASN_CONSTRUCTOR=$20;
 ASN_RFC1157_GETNEXTREQUEST=(ASN_CONTEXTSPECIFIC or ASN_CONSTRUCTOR or 1);
 tcpstate:array[0..11] of string=(
 '???','CLOSED','LISTENING','SYN_SENT','SEN_RECEIVED','ESTABLISHED','FIN_WAIT',
 'FIN_WAIT2','CLOSE_WAIT','CLOSING','LAST_ACK','TIME_WAIT');	
 tcpidentifiers:array[0..9] of integer=(1,3,6,1,2,1,6,13,1,1);
 udpidentifiers:array[0..9] of integer=(1,3,6,1,2,1,7,5,1,1);

var
 TcpInfoTable:tcpinfo;
 hIdentifier:asnobjectidentifier;
 hTrapEvent:thandle;
 bindList:RFC1157VarBindList;
 bindEntry:RFC1157VarBind;
 ol,currententry:ptcpinfo;
 errorStatus,errorIndex:asninteger;

function service(w:integer):string;
var
 p:pservent;
{ zz:ppchar;
 z:pchar;}
 q:string;
begin
 p:=getservbyport(bswap(w) shr 16,nil);
 q:=strl(w);
 if p<>nil then if (p^.s_name<>nil) then begin
  q:=q+' ('+string(p^.s_name);
{  zz:=p^.s_aliases;
  if zz<>nil then begin
   z:=zz^;
   while z<>nil do begin
    if z^=#0 then break;
    if string(z)<>string(p^.s_name) then q:=q+', '+string(z);
    inc(z,length(string(z))+1);
   end;
  end;{ KOD na tisteni aliasu}
  q:=q+')';
 end;
 service:=q;
end;

function gettcpstate(i:integer):string;
begin
if (i>=0) and (i<=11) then result:=tcpstate[i] else result:=tcpstate[0];
end;

var
 i:integer;
begin
{$ifdef debug}writeln('netstat');{$endif}
 if not(loadsnmp) then exit;
 fillchar(hIdentifier,sizeof(hidentifier),0);
 hTrapEvent:=0;
 if SnmpExtensionInit(GetCurrentTime,@hTrapEvent,@hIdentifier)=0 then begin
{$ifdef debug}writeln('snmp unavailable');{$endif}
  send_bstring(ss,'SNMP extensions not available!');
  exit;
 end;
{$ifdef debug}writeln('snmp ok');{$endif}
 send_bstring(ss,'<h1>TCP connections:</h1>');
 bindEntry.name.idLength:=$A;
 bindEntry.name.ids:=@tcpidentifiers[0];
 bindList.list:=@bindEntry;
 bindList.len:=1;
 TcpInfoTable.next:=nil;
 currentEntry:=@TcpInfoTable;
 send_bstring(ss,'<table><tr bgcolor=#aaaaaa><td>State</td><td>Local IP</td><td>Local port</td><td>Remote IP</td><td>Remote port</td></tr>');
 i:=0;
 repeat
  if(SnmpExtensionQuery(ASN_RFC1157_GETNEXTREQUEST,@bindList,@errorStatus,@errorIndex)=0) then begin
   send_bstring(ss,'<tr><td>SNMP error!</td></tr></table>');
   exit;
  end;
 if( bindEntry.name.idLength<$A) then break;
  if bindentry.name.ids^[9]<>i then begin
   currententry:=@tcpinfotable;
  end;
  i:=bindentry.name.ids^[9];
  with currententry^ do
  case i of
   1:state:=bindEntry.value.number;
   2:localip:=bswap(pinteger(bindEntry.value.address.stream)^);
   3:localport:=bindEntry.value.number;
   4:remoteip:=bswap(pinteger(bindEntry.value.address.stream)^);
   5:remoteport:=bindEntry.value.number;
  end;
  if currententry^.next=nil then begin
   getzero(currententry^.next,sizeof(tcpinfotable));
  end;
  currententry:=currententry^.next;
 until false;
 currententry:=@tcpinfotable;
 while currententry<>nil do begin
  with currententry^ do if state<>11 then begin {time_wait nezobrazovat}
   if remoteip=0 then remoteport:=0;
   if currententry.next<>nil then
   send_bstring(ss,'<tr><td>'+gettcpstate(state)+'</td><td>'+str_ip(localip)+'</td><td>'+service(localport)+'</td><td>'+str_ip(remoteip)+'</td><td>'+service(remoteport)+'</td></tr>');
  end;
  ol:=currententry^.next;
  if currententry<>@tcpinfotable then freemem(currententry,sizeof(tcpinfotable));
  currententry:=ol;
 end;
 send_bstring(ss,'</table>');

 send_bstring(ss,'<h1>Listening UDP connections:</h1>');
 bindEntry.name.idLength:=$A;
 bindEntry.name.ids:=@udpidentifiers[0];
 bindList.list:=@bindEntry;
 bindList.len:=1;
 send_bstring(ss,'<table><tr bgcolor=#aaaaaa><td>Local IP</td><td>Local port</td></tr><tr>');
 i:=0;
 repeat
  if(SnmpExtensionQuery(ASN_RFC1157_GETNEXTREQUEST,@bindList,@errorStatus,@errorIndex)=0) then begin
   send_bstring(ss,'<tr><td>SNMP error!</td></tr></table>');
   exit;
  end;
 if( bindEntry.name.idLength<$A) then break;
  if bindentry.name.ids^[9]<>i then begin
   if i<>0 then send_bstring(ss,'</td>');
   send_bstring(ss,'<td>');
  end;
  i:=bindentry.name.ids^[9];
  case i of
   1:send_bstring(ss,'<br>'+str_ip(bswap(pinteger(bindEntry.value.address.stream)^)));
   2:send_bstring(ss,'<br>'+service(bindEntry.value.number));
  end;
 until false;
 send_bstring(ss,'</tr></table>');
end;
